package cn.vipthink.aic.live.service;

package ..deTemp.1734161639370;

import cn.vipthink.aic.common.code.AicCode;
import cn.vipthink.aic.common.model.ListResponseVO;
import cn.vipthink.aic.common.model.ResultV2;
import cn.vipthink.aic.common.model.ResultV3;
import cn.vipthink.aic.live.annotation.RedissonCache;
import cn.vipthink.aic.live.domain.dto.goOutEva.AnswerLogStasticesDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.req.FinishedInfoReqDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.req.InfoReqDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.req.SaveRecordReqDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.req.TeacherInfoReqDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.FinishedInfoRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.InfoRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.KnowledgeRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.StudentAnswerDetailRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.StudentAnswerInfoDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.TeacherConfigRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.TeacherInfoRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.TeacherStatisticsDetailRespDto;
import cn.vipthink.aic.live.domain.dto.goOutEva.resp.TeacherStatisticsRespDto;
import cn.vipthink.aic.live.domain.entity.edu.OlLiveAnswerLog;
import cn.vipthink.aic.live.domain.entity.online.OlLive;
import cn.vipthink.aic.live.domain.entity.online.OlLiveStudent;
import cn.vipthink.aic.live.enums.live.CourseTypeEnum;
import cn.vipthink.aic.live.mapper.edu.OlLiveAnswerLogMapper;
import cn.vipthink.aic.live.mapper.edu.OlUserOptLogMapper;
import cn.vipthink.aic.live.mapper.online.OlLiveMapper;
import cn.vipthink.aic.live.mapper.online.OlLiveStudentMapper;
import cn.vipthink.aic.live.service.GoOutLargeLiveService;
import cn.vipthink.aic.live.service.edu.StudentCardBaseService;
import cn.vipthink.aiclass.courseware.api.knowledge.KnowledgeBusinessServiceI;
import cn.vipthink.aiclass.courseware.dto.query.knowledge.AdminGetPointListQuery;
import cn.vipthink.aiclass.courseware.enums.knowledge.LinkTypeEnum;
import cn.vipthink.aiclass.courseware.vo.knowledge.AdminKnowledgePointVO;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.google.common.collect.Lists;
import java.lang.invoke.SerializedLambda;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class GoOutEvaService {
  private static final Logger log = LoggerFactory.getLogger(cn.vipthink.aic.live.service.GoOutEvaService.class);
  
  @Autowired
  OlLiveAnswerLogMapper olLiveAnswerLogMapper;
  
  @Autowired
  OlLiveMapper olLiveMapper;
  
  @Autowired
  OlUserOptLogMapper olUserOptLogMapper;
  
  @Autowired
  OlLiveStudentMapper olLiveStudentMapper;
  
  @Autowired
  private KnowledgeBusinessServiceI knowledgeBusinessServiceI;
  
  @Autowired
  StudentCardBaseService studentCardBaseService;
  
  @Autowired
  cn.vipthink.aic.live.service.GoOutEvaService goOutEvaService;
  
  @Resource
  GoOutLargeLiveService goOutLargeLiveService;
  
  public ResultV2 saveRecord(SaveRecordReqDto reqDTO) {
    if (!checkValidUserId(reqDTO.getLiveId(), reqDTO.getUserId()))
      return ResultV2.SUCCESS(); 
    if (Objects.equals(OlLiveAnswerLog.ResultStatusEnum.NOT_FINISH.getType(), reqDTO.getResultStatus())) {
      LambdaQueryWrapper<OlLiveAnswerLog> completeQuery = new LambdaQueryWrapper();
      ((LambdaQueryWrapper)((LambdaQueryWrapper)((LambdaQueryWrapper)completeQuery.eq(OlLiveAnswerLog::getLiveId, reqDTO.getLiveId()))
        .eq(OlLiveAnswerLog::getUserId, reqDTO.getUserId()))
        .eq(OlLiveAnswerLog::getPageIndex, reqDTO.getPageIndex()))
        .ne(OlLiveAnswerLog::getResultStatus, OlLiveAnswerLog.ResultStatusEnum.NOT_FINISH.getType());
      Integer completeCount = this.olLiveAnswerLogMapper.selectCount((Wrapper)completeQuery);
      if (completeCount.intValue() > 0) {
        log.warn("GoOutEvaService.saveRecord 答题已完成,不处理未完成状态.req={}", reqDTO);
        return ResultV2.SUCCESS();
      } 
    } 
    LambdaQueryWrapper<OlLiveAnswerLog> olLiveAnswerLogLambdaQueryWrapper = new LambdaQueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)olLiveAnswerLogLambdaQueryWrapper.eq(OlLiveAnswerLog::getLiveId, reqDTO.getLiveId()))
      .eq(OlLiveAnswerLog::getUserId, reqDTO.getUserId()))
      .eq(OlLiveAnswerLog::getPageIndex, reqDTO.getPageIndex());
    Integer authNum = this.olLiveAnswerLogMapper.selectCount((Wrapper)olLiveAnswerLogLambdaQueryWrapper);
    OlLiveAnswerLog olLiveAnswerLog = OlLiveAnswerLog.builder().answerDetail(reqDTO.getAnswerDetail()).answerStartTime(new Date(reqDTO.getAnswerStartTime().longValue())).answerEndTime(new Date(reqDTO.getAnswerEndTime().longValue())).liveId(reqDTO.getLiveId()).userId(Integer.valueOf(reqDTO.getUserId().intValue())).pageIndex(reqDTO.getPageIndex()).coursewareSession(Integer.valueOf(1)).isDeleted(Integer.valueOf(1)).resultStatus(reqDTO.getResultStatus()).authNum(Integer.valueOf(authNum.intValue() + 1)).build();
    this.olLiveAnswerLogMapper.insert(olLiveAnswerLog);
    OlLive olLive = (OlLive)this.olLiveMapper.selectById(reqDTO.getLiveId());
    if (Objects.nonNull(olLive) && Objects.equals(Integer.valueOf(CourseTypeEnum.LARGE_LIVE.getCode()), olLive.getCourseType()))
      this.goOutLargeLiveService.saveSnap(reqDTO); 
    return ResultV2.SUCCESS();
  }
  
  public ResultV2<InfoRespDto> studentInfo(InfoReqDto reqDTO) {
    InfoRespDto infoRespDto = InfoRespDto.builder().currentPageIndex("").build();
    if (!checkValidUserId(reqDTO.getLiveId(), reqDTO.getUserId()))
      return ResultV2.SUCCESS(infoRespDto); 
    List<String> goOutConfigList = this.goOutEvaService.getGoOutConfigByLiveId(reqDTO.getLiveId());
    if (CollectionUtils.isEmpty(goOutConfigList))
      return ResultV2.SUCCESS(infoRespDto); 
    infoRespDto.setPageIndexList(goOutConfigList);
    LambdaQueryWrapper<OlLiveAnswerLog> lambdaQueryWrapper = new LambdaQueryWrapper();
    ((LambdaQueryWrapper)lambdaQueryWrapper.eq(OlLiveAnswerLog::getLiveId, reqDTO.getLiveId()))
      .eq(OlLiveAnswerLog::getUserId, reqDTO.getUserId());
    List<OlLiveAnswerLog> olLiveAnswerLogList = this.olLiveAnswerLogMapper.selectList((Wrapper)lambdaQueryWrapper);
    if (CollectionUtils.isEmpty(olLiveAnswerLogList))
      return ResultV2.SUCCESS(infoRespDto); 
    OlLiveAnswerLog lastOlLiveAnswerLog = olLiveAnswerLogList.stream().max(Comparator.comparing(OlLiveAnswerLog::getCreateTime)).get();
    infoRespDto.setCurrentPageIndex(lastOlLiveAnswerLog.getPageIndex());
    infoRespDto.setAnswerDetail(lastOlLiveAnswerLog.getAnswerDetail());
    Map<String, List<OlLiveAnswerLog>> pageIndexMap = (Map<String, List<OlLiveAnswerLog>>)olLiveAnswerLogList.stream().collect(Collectors.groupingBy(OlLiveAnswerLog::getPageIndex));
    Map<String, KnowledgeRespDto> questionList = new HashMap<>();
    for (Map.Entry<String, List<OlLiveAnswerLog>> entry : pageIndexMap.entrySet()) {
      OlLiveAnswerLog olLiveAnswerLog = ((List<OlLiveAnswerLog>)entry.getValue()).stream().max(Comparator.comparing(OlLiveAnswerLog::getCreateTime)).get();
      KnowledgeRespDto knowledgeRespDto = KnowledgeRespDto.builder().resultStatus(olLiveAnswerLog.getResultStatus()).pageIndex(entry.getKey()).build();
      questionList.put(entry.getKey(), knowledgeRespDto);
    } 
    infoRespDto.setQuestionList(questionList);
    return ResultV2.SUCCESS(infoRespDto);
  }
  
  @RedissonCache(name = "aic-live:getGoOutConfig", key = "#liveId", expire = 7200L)
  public List<String> getGoOutConfigByLiveId(Integer liveId) {
    OlLive olLive = (OlLive)this.olLiveMapper.selectById(liveId);
    if (Objects.isNull(olLive))
      return Lists.newArrayList(); 
    AdminGetPointListQuery adminGetPointListQuery = new AdminGetPointListQuery();
    adminGetPointListQuery.setChapterId(Long.valueOf(olLive.getCId().longValue()));
    adminGetPointListQuery.setPointType(Integer.valueOf(1));
    ResultV3<ListResponseVO<AdminKnowledgePointVO>> listResponseVOResultV3 = this.knowledgeBusinessServiceI.listPointList(adminGetPointListQuery);
    if (AicCode.SUCCESS.getCode() != listResponseVOResultV3.getCode())
      return Lists.newArrayList(); 
    ListResponseVO<AdminKnowledgePointVO> listResponseVOResultV3Data = (ListResponseVO<AdminKnowledgePointVO>)listResponseVOResultV3.getData();
    if (Objects.isNull(listResponseVOResultV3Data))
      return Lists.newArrayList(); 
    List<AdminKnowledgePointVO> adminKnowledgePointVOList = listResponseVOResultV3Data.getList();
    if (CollectionUtils.isEmpty(adminKnowledgePointVOList))
      return Lists.newArrayList(); 
    List<AdminKnowledgePointVO> adminKnowledgePointVOS = (List<AdminKnowledgePointVO>)adminKnowledgePointVOList.stream().filter(e -> Objects.equals(e.getLinkType(), LinkTypeEnum.GO_OUT_TO.getValue())).collect(Collectors.toList());
    List<String> configList = new ArrayList<>();
    for (AdminKnowledgePointVO adminKnowledgePointVO : adminKnowledgePointVOS) {
      StringBuilder stringBuilder = new StringBuilder();
      stringBuilder.append(adminKnowledgePointVO.getStage().intValue() - 1)
        .append("_").append(adminKnowledgePointVO.getItem().intValue() - 1);
      configList.add(stringBuilder.toString());
    } 
    return configList;
  }
  
  public ResultV2<FinishedInfoRespDto> finishedInfo(FinishedInfoReqDto reqDTO) {
    FinishedInfoRespDto finishedInfoRespDto = FinishedInfoRespDto.builder().build();
    if (!checkValidUserId(reqDTO.getLiveId(), reqDTO.getUserId()))
      return ResultV2.SUCCESS(finishedInfoRespDto); 
    List<String> goOutConfigByLiveId = this.goOutEvaService.getGoOutConfigByLiveId(reqDTO.getLiveId());
    String pagePrefix = reqDTO.getPage() + "_";
    LambdaQueryWrapper<OlLiveAnswerLog> lambdaQueryWrapper = new LambdaQueryWrapper();
    ((LambdaQueryWrapper)((LambdaQueryWrapper)lambdaQueryWrapper.eq(OlLiveAnswerLog::getLiveId, reqDTO.getLiveId()))
      .eq(OlLiveAnswerLog::getUserId, reqDTO.getUserId()))
      .like(OlLiveAnswerLog::getPageIndex, pagePrefix);
    List<OlLiveAnswerLog> olLiveAnswerLogList = this.olLiveAnswerLogMapper.selectList((Wrapper)lambdaQueryWrapper);
    Map<String, List<OlLiveAnswerLog>> pageIndexMap = (Map<String, List<OlLiveAnswerLog>>)olLiveAnswerLogList.stream().collect(Collectors.groupingBy(OlLiveAnswerLog::getPageIndex));
    List<KnowledgeRespDto> knowledgeRespDtoList = new ArrayList<>();
    goOutConfigByLiveId = (List<String>)goOutConfigByLiveId.stream().filter(e -> e.contains(pagePrefix)).collect(Collectors.toList());
    for (String pageIndex : goOutConfigByLiveId) {
      List<OlLiveAnswerLog> listByPageIndex = pageIndexMap.get(pageIndex);
      KnowledgeRespDto knowledgeRespDto = KnowledgeRespDto.builder().pageIndex(pageIndex).resultStatus(CollectionUtils.isEmpty(listByPageIndex) ? OlLiveAnswerLog.ResultStatusEnum.NOT_FINISH.getType() : ((OlLiveAnswerLog)listByPageIndex.get(listByPageIndex.size() - 1)).getResultStatus()).build();
      knowledgeRespDtoList.add(knowledgeRespDto);
    } 
    long totalTime = olLiveAnswerLogList.stream().filter(e -> Objects.nonNull(e.getAnswerStartTime())).mapToLong(this::getTime).sum();
    long correctNum = olLiveAnswerLogList.stream().filter(e -> Objects.equals(OlLiveAnswerLog.ResultStatusEnum.CORRECT.getType(), e.getResultStatus())).count();
    long errorNum = olLiveAnswerLogList.stream().filter(e -> Objects.equals(OlLiveAnswerLog.ResultStatusEnum.ERROR.getType(), e.getResultStatus())).count();
    long correctRate = BigDecimal.valueOf(correctNum).divide(BigDecimal.valueOf(goOutConfigByLiveId.size()), 2, RoundingMode.HALF_UP).multiply(BigDecimal.valueOf(100L)).longValue();
    finishedInfoRespDto.setAccuracy(correctRate);
    finishedInfoRespDto.setTotalAnswerTime(totalTime);
    finishedInfoRespDto.setKnowledgeRespDtoList(knowledgeRespDtoList);
    return ResultV2.SUCCESS(finishedInfoRespDto);
  }
  
  private long getTime(OlLiveAnswerLog olLiveAnswerLog) {
    long timdeDiffMilSec = olLiveAnswerLog.getAnswerEndTime().getTime() - olLiveAnswerLog.getAnswerStartTime().getTime();
    return timdeDiffMilSec / 1000L;
  }
  
  public ResultV2<TeacherInfoRespDto> teacherInfo(TeacherInfoReqDto reqDTO) {
    TeacherInfoRespDto teacherInfoRespDto = TeacherInfoRespDto.builder().build();
    List<String> goOutConfigByLiveId = this.goOutEvaService.getGoOutConfigByLiveId(reqDTO.getLiveId());
    if (CollectionUtils.isEmpty(goOutConfigByLiveId))
      return ResultV2.SUCCESS(teacherInfoRespDto); 
    List<Integer> userIds = CollectionUtils.isNotEmpty(reqDTO.getUserIds()) ? reqDTO.getUserIds() : this.olUserOptLogMapper.selectEnterStudentIdByLiveId(reqDTO.getLiveId());
    if (CollectionUtils.isEmpty(userIds))
      return ResultV2.SUCCESS(teacherInfoRespDto); 
    LambdaQueryWrapper<OlLiveAnswerLog> olLiveAnswerLogLambdaQueryWrapper = new LambdaQueryWrapper();
    olLiveAnswerLogLambdaQueryWrapper.eq(OlLiveAnswerLog::getLiveId, reqDTO.getLiveId());
    List<OlLiveAnswerLog> olLiveAnswerLogList = this.olLiveAnswerLogMapper.selectList((Wrapper)olLiveAnswerLogLambdaQueryWrapper);
    Map<Integer, List<OlLiveAnswerLog>> userIdMap = (Map<Integer, List<OlLiveAnswerLog>>)olLiveAnswerLogList.stream().collect(Collectors.groupingBy(OlLiveAnswerLog::getUserId));
    Map<Integer, String> studentNameMap = this.studentCardBaseService.queryUserInfo(userIds);
    List<StudentAnswerInfoDto> studentAnswerInfoDtoList = new ArrayList<>();
    for (Integer userId : userIds) {
      StudentAnswerInfoDto studentAnswerInfoDto = getStudentAnswerInfoDto(userIdMap.get(userId), userId, studentNameMap.get(userId), goOutConfigByLiveId);
      studentAnswerInfoDtoList.add(studentAnswerInfoDto);
    } 
    studentAnswerInfoDtoList.sort(Comparator.<StudentAnswerInfoDto, Comparable>comparing(StudentAnswerInfoDto::getAccuracy).reversed());
    teacherInfoRespDto.setStudentAnswerInfoDtoList(studentAnswerInfoDtoList);
    teacherInfoRespDto.setShowFlag(true);
    return ResultV2.SUCCESS(teacherInfoRespDto);
  }
  
  private StudentAnswerInfoDto getStudentAnswerInfoDto(List<OlLiveAnswerLog> olLiveAnswerLogList, Integer userId, String studentName, List<String> goOutConfigByLiveId) {
    StudentAnswerInfoDto studentAnswerInfoDto = StudentAnswerInfoDto.builder().userId(userId).name(studentName).build();
    if (CollectionUtils.isEmpty(olLiveAnswerLogList) || CollectionUtils.isEmpty(goOutConfigByLiveId)) {
      studentAnswerInfoDto.setAccuracy(0L);
      return studentAnswerInfoDto;
    } 
    olLiveAnswerLogList = (List<OlLiveAnswerLog>)olLiveAnswerLogList.stream().filter(p -> goOutConfigByLiveId.contains(p.getPageIndex())).collect(Collectors.toList());
    Map<String, List<OlLiveAnswerLog>> pageIndexMap = (Map<String, List<OlLiveAnswerLog>>)olLiveAnswerLogList.stream().collect(Collectors.groupingBy(OlLiveAnswerLog::getPageIndex));
    long correctNum = olLiveAnswerLogList.stream().filter(e -> OlLiveAnswerLog.ResultStatusEnum.CORRECT.getType().equals(e.getResultStatus())).count();
    long totalNum = goOutConfigByLiveId.size();
    long correctRate = (totalNum > 0L) ? (correctNum * 100L / totalNum) : 0L;
    studentAnswerInfoDto.setAccuracy(correctRate);
    List<StudentAnswerDetailRespDto> studentAnswerDetailRespDtoList = new ArrayList<>();
    for (String pageIndex : goOutConfigByLiveId) {
      StudentAnswerDetailRespDto studentAnserDetailRespDto = getStudentAnserDetailRespDto(pageIndexMap.get(pageIndex), pageIndex);
      studentAnswerDetailRespDtoList.add(studentAnserDetailRespDto);
    } 
    studentAnswerInfoDto.setAccuracy(correctRate);
    studentAnswerInfoDto.setStudentAnswerDetailRespDtoList(studentAnswerDetailRespDtoList);
    return studentAnswerInfoDto;
  }
  
  private StudentAnswerDetailRespDto getStudentAnserDetailRespDto(List<OlLiveAnswerLog> olLiveAnswerLogList, String pageIndex) {
    StudentAnswerDetailRespDto studentAnswerDetailRespDto = StudentAnswerDetailRespDto.builder().pageIndex(pageIndex).resultStatus(OlLiveAnswerLog.ResultStatusEnum.NOT_FINISH.getType()).build();
    if (CollectionUtils.isEmpty(olLiveAnswerLogList))
      return studentAnswerDetailRespDto; 
    long answerTime = getAnswerTimeByList(olLiveAnswerLogList);
    OlLiveAnswerLog olLiveAnswerLog = olLiveAnswerLogList.stream().max(Comparator.comparing(OlLiveAnswerLog::getCreateTime)).get();
    studentAnswerDetailRespDto.setAnswerTime(answerTime);
    studentAnswerDetailRespDto.setAuthNum(olLiveAnswerLog.getAuthNum());
    studentAnswerDetailRespDto.setResultStatus(olLiveAnswerLog.getResultStatus());
    return studentAnswerDetailRespDto;
  }
  
  private long getAnswerTimeByList(List<OlLiveAnswerLog> olLiveAnswerLogList) {
    long answerTime = 0L;
    for (OlLiveAnswerLog dto : olLiveAnswerLogList) {
      if (Objects.isNull(dto.getResultStatus()) || Objects.isNull(dto.getAnswerEndTime()))
        continue; 
      answerTime += (dto.getAnswerEndTime().getTime() - dto.getAnswerStartTime().getTime()) / 1000L;
    } 
    return answerTime;
  }
  
  private TeacherStatisticsDetailRespDto getTeacherStatisticsDetailRespDto(String pageIndex, Integer userSize, Integer liveId, AnswerLogStasticesDto answerLogStasticesDto) {
    TeacherStatisticsDetailRespDto teacherStatisticsDetailRespDto = TeacherStatisticsDetailRespDto.builder().avgAnswerTime(BigDecimal.ZERO).unfinishedRate(100).pageIndex(pageIndex).build();
    if (Objects.isNull(answerLogStasticesDto))
      return teacherStatisticsDetailRespDto; 
    int answerUserCount = answerLogStasticesDto.getAnswerUserCount().intValue();
    if (answerUserCount < 1)
      return teacherStatisticsDetailRespDto; 
    Long answerTime = Optional.<Long>ofNullable(answerLogStasticesDto.getAnswerTime()).orElse(Long.valueOf(0L));
    BigDecimal avgAnswerTime = BigDecimal.valueOf(answerTime.longValue()).divide(BigDecimal.valueOf(answerUserCount), 2, RoundingMode.HALF_UP);
    Integer corectCount = Optional.<Integer>ofNullable(answerLogStasticesDto.getCorrectCount()).orElse(Integer.valueOf(0));
    int correctRate = BigDecimal.valueOf(corectCount.intValue()).divide(BigDecimal.valueOf(userSize.intValue()), 2, RoundingMode.HALF_UP).multiply(BigDecimal.valueOf(100L)).intValue();
    Integer errorCount = Optional.<Integer>ofNullable(answerLogStasticesDto.getErrorCount()).orElse(Integer.valueOf(0));
    int errorRate = BigDecimal.valueOf(errorCount.intValue()).divide(BigDecimal.valueOf(userSize.intValue()), 2, RoundingMode.HALF_UP).multiply(BigDecimal.valueOf(100L)).intValue();
    teacherStatisticsDetailRespDto.setCorrectRate(correctRate);
    teacherStatisticsDetailRespDto.setErrorRate(errorRate);
    teacherStatisticsDetailRespDto.setUnfinishedRate(100 - correctRate - errorRate);
    teacherStatisticsDetailRespDto.setAvgAnswerTime(avgAnswerTime);
    return teacherStatisticsDetailRespDto;
  }
  
  public ResultV2<TeacherConfigRespDto> teacherConfig(TeacherInfoReqDto reqDTO) {
    List<String> goOutConfigByLiveId = getGoOutConfigByLiveId(reqDTO.getLiveId());
    TeacherConfigRespDto teacherConfigRespDto = TeacherConfigRespDto.builder().pageIndexList(goOutConfigByLiveId).build();
    return ResultV2.SUCCESS(teacherConfigRespDto);
  }
  
  private boolean checkValidUserId(Integer liveId, Long userId) {
    if (userId.longValue() > 2147483647L)
      return false; 
    LambdaQueryWrapper<OlLiveStudent> lambdaQueryWrapper = new LambdaQueryWrapper();
    ((LambdaQueryWrapper)lambdaQueryWrapper.eq(OlLiveStudent::getLiveId, liveId))
      .eq(OlLiveStudent::getStudentId, Integer.valueOf(userId.intValue()));
    Integer selectCount = this.olLiveStudentMapper.selectCount((Wrapper)lambdaQueryWrapper);
    return (selectCount.intValue() > 0);
  }
  
  public ResultV2<TeacherStatisticsRespDto> teacherStatistics(TeacherInfoReqDto reqDTO) {
    TeacherStatisticsRespDto teacherStatisticsRespDto = TeacherStatisticsRespDto.builder().build();
    List<String> goOutConfigByLiveId = this.goOutEvaService.getGoOutConfigByLiveId(reqDTO.getLiveId());
    if (CollectionUtils.isEmpty(goOutConfigByLiveId))
      return ResultV2.SUCCESS(teacherStatisticsRespDto); 
    Integer userCount = this.olUserOptLogMapper.countEnterStudentIdByLiveId(reqDTO.getLiveId());
    List<AnswerLogStasticesDto> answerLogStasticesDtos = this.olLiveAnswerLogMapper.answerStatices(reqDTO.getLiveId());
    if (CollectionUtils.isEmpty(answerLogStasticesDtos))
      return ResultV2.SUCCESS(teacherStatisticsRespDto); 
    Map<String, AnswerLogStasticesDto> pageIndexMap = (Map<String, AnswerLogStasticesDto>)answerLogStasticesDtos.stream().collect(Collectors.toMap(AnswerLogStasticesDto::getPageIndex, e -> e, (o, n) -> o));
    List<TeacherStatisticsDetailRespDto> teacherStatisticsDetailRespDtoList = new ArrayList<>();
    for (String pageIndex : goOutConfigByLiveId) {
      TeacherStatisticsDetailRespDto teacherStatisticsDetailRespDto = getTeacherStatisticsDetailRespDto(pageIndex, userCount, reqDTO.getLiveId(), pageIndexMap.get(pageIndex));
      teacherStatisticsDetailRespDtoList.add(teacherStatisticsDetailRespDto);
    } 
    teacherStatisticsRespDto.setShowFlag(true);
    teacherStatisticsRespDto.setList(teacherStatisticsDetailRespDtoList);
    return ResultV2.SUCCESS(teacherStatisticsRespDto);
  }
}
